// browser_startup.cpp : R\[ AvP[ṼGg |Cg`܂B
//
//#include "stdafx.h"

//#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

//#include "libpasori.h"
//#include "libpasori_command.h"
//#include "libpasori_com.h"
#include "libpafe.h"

#define FELICA_CMD_PUSH 0xb0
#define FELICA_ANS_PUSH 0xb1
#define FELICA_CMD_SEND_IDM 0xa4
#define FELICA_ANS_SEND_IDM 0xa5

int main(int argc, char *argv[])
{
	char url[256];
	pasori* p;
	felica* f;
	int i;
	int data_size;
	int cmd_size;
	int resp_size;
	int param_size;
	int url_size;
	uint8 cmd[256];
	uint8 resp[256];
	unsigned short sum;
	int l;
	sum=0;

	p = pasori_open();
	if(!p){
		printf("error\n");
		exit(-1);
	}
	pasori_init(p);
	f = (felica*)felica_polling(p,FELICA_POLLING_ANY,0,0); /* get ID */
	if(f && argc == 2){
		sprintf((char *)url,"%s",argv[1]);
		url_size = strlen(url);
		param_size = url_size + 2;	
		data_size = param_size + 6; /* data_section size */
		cmd[0] = FELICA_CMD_PUSH; /* push command */
		cmd[9] = data_size; /* */
		cmd[10] = 0x01; /* separate_parts_number */
		cmd[11] = 0x02; /* sepatate_parts_header control_infomation */
		cmd[12] = L8(param_size); /* sepatate_parts_header param_size */
		cmd[13] = H8(param_size); /* little endian */
		cmd[14] = L8(url_size); /* little endian */
		cmd[15] = H8(url_size);
		memcpy(&cmd[16],url,url_size);
		for(i=10;i<=(15+url_size);i++){
			sum += cmd[i];
		}
		sum = 0 - sum;
		cmd[16+url_size] = H8(sum); /* check_sum (big endian) */
		cmd[17+url_size] = L8(sum);
		memcpy(&cmd[1],f->IDm,8); /* set IDm */
		cmd_size = 18+url_size;
		pasori_write(p,(uint8 *)cmd,&cmd_size);
		resp_size = 255;
		l = pasori_read(p,(uint8 *)resp,&resp_size);
		if(l != 0){
			printf("error\n");
			exit(-1);
		}
		if(resp[0] != FELICA_ANS_PUSH){
			Log("!!!INVALID RETURN VALUE (%d)\n",resp[0]);
			exit(-1);
		}
	} else if(f && argc == 1) {
		cmd[0] = FELICA_CMD_SEND_IDM;
		cmd[9] = 0;
		cmd_size = 10;
		pasori_write(p,(uint8 *)cmd,&cmd_size);
		resp_size = 255;
		l = pasori_read(p,(uint8 *)resp,&resp_size);
		if(l != 0){
			printf("error\n");
			exit(-1);
		}
		if(resp[0] != FELICA_ANS_SEND_IDM){
			Log("!!!INVALID RETURN VALUE (%d)\n",resp[0]);
			exit(-1);
		}
	}
	free(f);
	pasori_close(p);
	return 0;
}

